# RTSA License 介绍
每个上线的设备，都需要一个激活的 License 来配合使用。每个 License 都有相应的有效期，并且从激活的那一时刻算起。激活后会生成相应的 License 证书文件，在之后每次使用设备时，该文件用来验证 License 的有效性。

# RTSA License 流程

## 1. 获取 Agora RESTful API 需要的客户 ID 和客户密钥
由于激活 License 需要使用 Agora RESTful API，因此你需要进行 HTTP 基本认证，即使用 Agora 提供的客户 ID 和客户密钥生成一个 Authorization 字段（使用 Base64 算法编码）。
1. 登录 [Agora 控制台](https://console.agora.io/)，点击页面右上角的用户名，在下拉列表中打开 RESTful API 页面。
2. 点击 **添加密钥** 按钮。在下方的页面中会生成新的客户 ID 和客户密钥，在右边的操作栏点击 **提交** 按钮。
3. 页面显示 **创建成功** 提示信息后，在相应的客户密钥栏点击 **下载** 按钮。
4. 保存下载下来的 **key_and_secret.txt** ，里面包含客户 ID 和客户密钥，稍后激活 License 时会用到。注意：这对 ID 和密钥和 具体哪个 App ID 无关，只和声网的账号有关。

## 2. 获取 License Key

如果你需要购买商用 License，请联系声网销售(sales@agora.io)。

## 3. License 辅助工具
在之前编译示例项目（hello_rtsa）的时候，你已经同时编译出了 License 辅助工具：**license_activator**

## 4. License 激活
当你已经完成购买一定数量的商用 License，就可以进行激活操作。每次激活的时候，需要提供设备的唯一标识码，比如该设备的 IMEI 号码。每次激活成功后，将会消耗一个购买的 License。当购买的 License 数量消耗完，激活操作会失败。

以下是激活命令：
```
$ ./license_activator --appId YOUR_APP_ID --customerKey YOUR_KEY --customerSecret YOUR_SECRET --deviceId YOUR_DEVICE_ID --certOutputDir .
```
请注意：
- 参数 `YOUR_APPID` 需要替换为你创建的 App ID.
- 参数 `YOUR_KEY` 需要替换为你刚才保存的 `key_and_secret.txt` 文件里的 key值
- 参数 `YOUR_SECRET` 需要替换为你刚才保存的 `key_and_secret.txt` 文件里的 secret值
- 参数 `YOUR_DEVICE_ID` 需要替换为设备的唯一标识码，比如设备的 IMEI 号码。该唯一标识码不能超过 128 字节。不同设备的唯一标识码不可重复

激活成功后，默认在当前目录生成 **certificate.bin** , 它是和这个设备绑定的 License 证书。hello_rtsa 运行时会加载这个文件，并在初始化 SDK 之前通过 `agora_rtc_license_verify` 接口调用来验证 License 证书的有效性。只有通过验证，SDK 才可以正常运行。
之后，设备在每次运行RTSA-Lite SDK前，都会调用`agora_rtc_license_verify`方法来验证 License 证书的有效性。只有通过验证，SDK初始化才能够成功。

## 5. 验证 License 是否有效
把刚才激活生成的 **certificate.bin** 文件拷贝到 hello_rtsa 的同一目录下（可能会覆盖原来的同名文件）。

然后再次运行示例项目（hello_rtsa）
```
$ ./hello_rtsa --appId YOUR_APPID --channelId hello_demo
```
如果你看到终端打印出 `Verify license successfully` ，说明该 License 证书验证通过！






